( function( $ ) {
    "use strict";
    $(window).on('load', function() {
        $(window).off('beforeunload');//Disable “Changes you made may not be saved” pop-up window.
        $('.wrap').prepend('<div id="mstcplfwpb-message" class="updated mstcplfwpb-alert-savechange"><p class="mstcplfwpb-save-change"></p></div>');
        $('#publishing-action').html('');
        var html_action = '',
            addnew      = '',
            save_text   = '';
        if(mst_product_layout_data.is_page=='adnew'){
            html_action = '<button class="button button-primary button-large" id="mst-product-layout-publish-template">'+mst_product_layout_data.publish+'</button>';
            $('#vc_navbar .vc_navbar-nav').prepend('<li class="vc_pull-right"><a class="vc_btn vc_btn-sm vc_navbar-btn vc_btn-primary mstcplfwpb-savechange-editting" id="mst-product-layout-publish-template">'+mst_product_layout_data.publish+'</a></li>');
            $('.wp-heading-inline').text(mst_product_layout_data.add_template);
            save_text = mst_product_layout_data.saved;
        }else{
            html_action = '<button class="button button-primary" id="mst-product-layout-update-template">'+mst_product_layout_data.update+'</button>';
            $('#vc_navbar .vc_navbar-nav').prepend('<li class="vc_pull-right"><a class="vc_btn vc_btn-sm vc_navbar-btn vc_btn-primary mstcplfwpb-savechange-editting" id="mst-product-layout-update-template">'+mst_product_layout_data.update+'</a></li>');
            addnew = mst_product_layout_data.edit_template+' <a href="'+mst_product_layout_data.url_add_new+'" class="hide-if-no-js page-title-action">'+mst_product_layout_data.add_template+'</a>';
            $(".wp-heading-inline").html(addnew);
            $('#title-prompt-text').addClass('screen-reader-text');
            $('#title').val(mst_product_layout_data.template_name);
            save_text = mst_product_layout_data.updated;
        }
        $('body').prepend('<div class="vc_message success mstwfcwpb-alert-message-success">'+save_text+'</div>');
        $('#publishing-action').html(html_action);
        if(mst_product_layout_data.vc_template_custom_css){
            $('#vc_post-custom-css').val(mst_product_layout_data.vc_template_custom_css);
            $('#vc_post-css-badge').show();
        }
        
        // PUBLISH
        $(document).on("click","#mst-product-layout-publish-template",function(event){
            event.preventDefault();
            var _this = $(this);
            publish_template_product_layout(_this);
        });
        // UPDATE
        $(document).on("click","#mst-product-layout-update-template",function(event){
            event.preventDefault();
            var _this = $(this);
            update_template_product_layout(_this);
        });
    });
    function publish_template_product_layout(_this){
        _this.addClass('updating-message');
        var template_type   = mst_product_layout_data.is_template,
            content         = $('#wp-content-editor-container .wp-editor-area').val(),
            language        = mst_product_layout_data.language,
            custom_css      = $('#vc_post-custom-css').val(),
            title           = $("#title").val(),
            btsavechange    = $('.mstcplfwpb-savechange-editting');
            btsavechange.text(mst_product_layout_data.popup_loading_text);
        $.ajax({
            url: ajaxurl,
            type: 'POST',
            data: {
                'action'            : 'mst_product_layout_publish',
                'nonce'             : mst_product_layout_data.nonce,
                'post_id'           : mst_product_layout_data.post_id,
                'custom_css'        : custom_css,
                'title'             : title,
                'content'           : content,
                'template_type'     : template_type,
                'language'          : language
            }
        })
        .done(function (res) {
            _this.removeClass('updating-message');
            btsavechange.text(mst_product_layout_data.publish);
            if(res.success){
                mstcplfwpb_alert(mst_product_layout_data.saved);
                redirect_template_indentify(template_type,language);
            } 
        })
        .fail(function (res) {
            _this.removeClass('updating-message');
            btsavechange.text(mst_product_layout_data.publish);
            console.log(res);
        });
    }
    function update_template_product_layout(_this){
        _this.addClass('updating-message');
        var custom_css      = $('#vc_post-custom-css').val(),
            content         = $('#wp-content-editor-container .wp-editor-area').val(),
            title           = $("#title").val(),
            btsavechange    = $('.mstcplfwpb-savechange-editting');
        btsavechange.text(mst_product_layout_data.popup_loading_text)
        $.ajax({
            url: ajaxurl,
            type: 'POST',
            data: {
                'action'            : 'mst_product_layout_update',
                'nonce'             : mst_product_layout_data.nonce,
                'id'                : mst_product_layout_data.is_page,
                'title'             : title,
                'content'           : content,
                'post_id'           : mst_product_layout_data.post_id,
                'custom_css'        : custom_css,
                'template_type'     : mst_product_layout_data.is_template
            }
        })
        .done(function (res) {
            _this.removeClass('updating-message');
            btsavechange.text(mst_product_layout_data.update);
            if(res.success){
                mstcplfwpb_alert(mst_product_layout_data.updated);
            } 
        })
        .fail(function (res) {
            _this.removeClass('updating-message');
            btsavechange.text(mst_product_layout_data.update);
            console.log(res);
        });
    }
    function mstcplfwpb_alert(alert_text){
        $(".mstcplfwpb-alert-savechange").show();
        $(".vc_fullscreen .vc_message.success.mstwfcwpb-alert-message-success").addClass('mstwfcwpb-updated');
        $(".mstcplfwpb-save-change").html(alert_text);
        $("html, body").animate({ scrollTop: 0 }, "200");
        setTimeout(function() {
            $(".mstcplfwpb-alert-savechange,.vc_fullscreen .vc_message.success.mstwfcwpb-alert-message-success").fadeOut(1000);
        }, 4000);
    }
    function redirect_template_indentify(type,language=""){
        var param_lang = language !='' ? '&lang='+language : '';
        var types = ['category','single','tags','brand','shop','attribute','search','loop'];
        if(types.includes(type)){
            window.location='admin.php?page=mst_cplfvc-active-templates&type='+type+param_lang;
        }else{
            window.location='admin.php?page=mst_cplfvc-active-templates'+param_lang;
        }
        
    }
    
} )( jQuery );