<?php
namespace mysterious\productlayout\classes;
class functions{
    private static $_instance = null;
    private $wpdb;
    const post_type = 'mstcplfwpb';
    public function __construct()
    {     
        global $wpdb;
        $this->wpdb = $wpdb;
    }

    public static function instance()
    {
        if (is_null(self::$_instance)) {
            self::$_instance = new self();
        }
        return self::$_instance;
    }
    public function is_active_wpb(){
        return defined('WPB_VC_VERSION') ? true : false;
    }
    public function is_check_require(){
        $flag = false;
        if(defined('WPB_VC_VERSION') && defined('WOOCOMMERCE_VERSION')){
            $flag = true;
        }
        return $flag;
    }
    // GET POST TYPE TEMPLATE
    public function get_post_type(){
        return  self::post_type;
    }
    // REGISTER POST TYPE
    public function register_post_type()
    {
        $add_edit_template = isset($_GET['edit']) ? esc_html__('Edit Template', 'customize-product-layout-builder-for-visual-composer' ) : esc_html__('Add New Template', 'customize-product-layout-builder-for-visual-composer' );
        $label = array(
            'name'                  => esc_html__('WooCommerce Templates',MST_CPLFVC),
            'singular_name'         => esc_html__('WooCommerce Templates',MST_CPLFVC),
            'add_new'               => esc_html($add_edit_template),
            'add_new_item'          => esc_html($add_edit_template),
            'new_item'              => esc_html__('New Template', MST_CPLFVC ),
            'edit_item'             => esc_html__('Edit Template', MST_CPLFVC )
        );
        $args = array(
            'labels' => $label,
            'description' => '',
            'supports' => array(
                'title',
                'editor'
            ),
			'public'                => true,
			'rewrite'               => array('slug' => self::post_type),
			'menu_icon'             => 'dashicons-admin-page',
			'show_ui'               => true,
			'show_in_menu'          => false,
			'show_in_nav_menus'     => false,
			'exclude_from_search'   => true,
			'capability_type'       => 'post',
			'hierarchical'          => false,
			
        );
        register_post_type(self::post_type, $args);
     
    }
    // GET TEMPLATE BY ID
    public function get_info_by_id($type_product,$template_id)
    {
        $table              = $this->get_table_by_type_template($type_product);
        $sql                = "SELECT * FROM $table WHERE ID=$template_id";
        $row_template_edit  = $this->get_template($sql);
        if(isset($row_template_edit->title)){
            $check_css  = false;
            $custom_css = $row_template_edit->images;
            if(!empty($custom_css)){
                if($custom_css=='template.png'){
                    $check_css = true;
                }else{
                    $check_css = strpos($custom_css,"preview.png");
                    if(!$check_css){
                        $check_css = strpos($custom_css,"add_layout.png");
                    }
                }
            }
            $info           =  array(
                'id'            => $template_id,
                'title'         => $row_template_edit->title,
                'content'       => $row_template_edit->content,
                'custom_css'    => !$check_css ? $custom_css : false
            );
            return $info;
        }
        return false;
    }
    
    public function get_localize_script()
    {
        $type_template  = isset($_GET['type']) && !empty($_GET['type']) ? sanitize_text_field($_GET['type']) : false;
        $template_id    = isset($_GET['post_type']) && isset($_GET['edit']) && !empty($_GET['edit']) ? sanitize_text_field($_GET['edit']) : 0;
        $query_arg      = $type_template ? array('post_type' => self::post_type,'type' => $type_template) : array('post_type' => self::post_type);
        $query_arg_edit = array();
        if(isset($_GET['edit']) && !empty($_GET['edit'])){
            $query_arg_edit         = $query_arg;
            $query_arg_edit['edit'] = $template_id;
        }
        $info_by_template           = $this->get_info_by_id($type_template,$template_id);
        $localize_script = array(
            'ajaxurl'               =>  admin_url('admin-ajax.php'),
            'nonce'                 =>  wp_create_nonce("product-layout-nonce"),
            'home_url'              =>  home_url(),
            'popup_save_change'     =>  esc_html__('Save Changes',MST_CPLFVC),
            'popup_close_frame'     =>  esc_html__('Close',MST_CPLFVC),
            'popup_loading_text'    =>  esc_html__('Loading...',MST_CPLFVC),
            'saved'                 =>  esc_html__('Saved changes',MST_CPLFVC),
            'publish'               =>  esc_html__('Publish',MST_CPLFVC),
            'update'                =>  esc_html__('Update',MST_CPLFVC),
            'is_template'           =>  $type_template ? $type_template : '',
            'add_template'          =>  esc_html__('Add New Template',MST_CPLFVC),
            'template_name'         =>  $info_by_template ? $info_by_template['title'] : '',
            'edit_template'         =>  esc_html__('Edit Template',MST_CPLFVC),
            'updated'               =>  esc_html__('Successfully updated!',MST_CPLFVC),
            'deleted'               =>  esc_html__('Deleted',MST_CPLFVC),
            'sure'                  =>  esc_html__('Are you sure?',MST_CPLFVC),
            'sure_delete_this'      =>  esc_html__('Are you sure will delete this template?',MST_CPLFVC),
            'language'              =>  $this->current_language(),
            'is_page'               =>  $template_id==0 ? 'adnew' : $template_id,
            'language'              =>  $this->current_language(),
            'url_add_new'           =>  add_query_arg( $query_arg, esc_url(admin_url('post-new.php')) ),
            'url_edit'              =>  add_query_arg( $query_arg_edit, esc_url(admin_url('post-new.php')) ),
            'url_templates'         =>  add_query_arg( array('page' => 'mst_cplfvc-active-templates'), esc_url(admin_url('admin.php')) )
        );
        return $localize_script;
    }

    public function get_awesome()
    {
        $site       = '//netdna.bootstrapcdn.com';
        $folder     = 'font-awesome';
        $version    = '3.1.1';
        $file       = 'css/font-awesome.css';
        $src        = $site.'/'.$folder.'/'.$version.'/'.$file;
        return $src;
    }

    public function get_table_name($string)
    {
        $table_name = $this->wpdb->prefix . $string;
        return $table_name;
    }

    public function get_term_id()
    {
        global $wp_query;
        $term_id = $wp_query->get_queried_object_id();
        return $term_id;
    }
    // CHECK IS PRODUCT LAYOUT PAGE
    public function is_product_attribute()
    {
        global $wp_query;
        $object = $wp_query->get_queried_object();
        $flag   = ( isset($object->taxonomy) && 'pa_' === substr($object->taxonomy, 0, 3) ) ? true : false;
        return $flag;
    }

    public function is_product_layout($page='shop')
    {
        $is_page = false;
        switch ($page) {
            case 'category':
                $is_page = is_tax('product_cat') && is_product_category();
                break;
            case 'tags':
                $is_page = is_tax('product_tag') && is_product_tag();
                break;
            case 'brand':
                $is_page = is_tax('product_brand');
                break;
            case 'single':
                $is_page = is_singular('product');
                break;
            case 'attribute':
                $is_page = $this->is_product_attribute();
                break;
            default:
                $is_page = is_shop();
        }
        return $is_page;
    }

    public function get_archive()
    {
        $data = false;
        global $wp_query;
        $object     = $wp_query->get_queried_object();
        $archives   = array(
            'category'  => 'product_cat',
            'tags'      => 'product_tag',
            'brand'     => 'product_brand',
            'attribute' => isset($object->taxonomy) ? $object->taxonomy : false
        );
        $term_id 	= $this->get_term_id();
        foreach( $archives as $type => $taxonomy )
        {
            if( $this->is_product_layout($type) )
            {
                $data = array(
                    'taxonomy'  => $taxonomy,
                    'term'      => get_term_by('id', $term_id, $taxonomy)
                );
                break;
            }
		}
        return $data;
    }
    public function get_table_by_type_template($type)
    {
        $types  = array('shop','category','single','tags','brand','attribute','search','loop'); 
        if( in_array($type,$types) ){
            $table  = $this->get_table_name('mst_cplfvc_product_'.$type);
        }else{
            $table  = $this->get_table_name('mst_cplfvc_product_shop');
        }
        return $table;
    }

    public function show_post_css($type_template,$template_id=false)
    {
        $value = false;
        if($template_id){
            $info       = $this->get_info_by_id($type_template,$template_id);
            $value      = $info['custom_css'] ? $info['custom_css'] : '';
        }
        return $value;
    }

    public function add_style_css_wpbakery($template_id,$content)
    {
        $css  = '';
        $types = array('shop','category','tags','single','brand','attribute', 'search');
        foreach($types as $key => $value){
            if( $this->is_product_layout($value) ){
                $type = $value;
                break;
            }
        }
        if (defined('WPB_VC_VERSION')) {
            $css = apply_filters( 'vc_base_build_shortcodes_custom_css', visual_composer()->parseShortcodesCustomCss( $content) );   
        }
        $custom_css = $this->show_post_css($type,$template_id);
        if(!empty($custom_css)){
            $css = $css ? $css.$custom_css : $custom_css;
        }
        if (!empty($css)) {
            echo '<style>'.esc_html($css).'</style>';
        }
    }

    public function show_template_content($template_id,$content)
    {
        if($this->is_active_wpb()){
            echo do_shortcode($content);
            $this->add_style_css_wpbakery($template_id,$content);
        }
    }

    public function site_active_wpml()
    {
        $flag = false;
        if (defined('ICL_SITEPRESS_VERSION')) {
            global $sitepress;
            $flag           = true;
            $defaultLang    = $sitepress->get_default_language();
            $currentLang    = ICL_LANGUAGE_CODE;
        }elseif ( defined( 'POLYLANG_VERSION' ) ) {
            $flag           = true;
            $defaultLang    = pll_default_language('slug');
            $currentLang    = pll_current_language('slug');
            $currentLang    = !empty($currentLang) ? $currentLang : $defaultLang;
        }
        if($flag){
            return array(
                'language_default'  => $defaultLang,
                'language'          => $currentLang
            );
        }
        return false;
    }

    public function current_language()
    {
        $checkWpml = $this->site_active_wpml();
        if ($checkWpml) {
            return $checkWpml["language_default"] == $checkWpml["language"] ? "" : $checkWpml["language"];
        } else {
            return "";
        }
    }

    public function currentTheme()
    {
        $theme = wc_get_theme_slug_for_templates();
        return strtolower($theme);
    }

    public function get_attribute_id()
    {
        global $wp_query;
        $object         = $wp_query->get_queried_object();
        $attribute_id   = isset($object->taxonomy) ? wc_attribute_taxonomy_id_by_name($object->taxonomy) : 0;
        return $attribute_id; 
    }

    public function get_template_active_by_language($table,$type="shop",$term_id=false)
    {
        $id = $flag = false;
        $language = $this->current_language();
        $where = "active='1' AND (language = '" . $language . "')";
        $template_result = $this->wpdb->get_row( "SELECT * FROM $table WHERE $where");
        $types = array('category','tags','brand','single','attribute');
        if( in_array($type, $types) ){
            if($type === "single"){
                $id = $term_id;
            }else{
                $term_name_archive = !empty($language) ? 'mst_cplfvc_product_'.$type.'_'.$language : 'mst_cplfvc_product_'.$type;
                $id = get_term_meta($term_id,$term_name_archive, true);
                if( $type === 'attribute' && empty($id) ){
                    $attribute_id   = $this->get_attribute_id();
                    $name           = 'mst_template_attribute_'.$attribute_id;
                    $option_name    = !empty($language) ? $name.'_'.$language : $name;
                    $id             = get_option($option_name);
                }
            }
            if ( !empty($id) ) {
                if ($id == "active") {
                    if($template_result){
                        $flag = true;
                    }
                } else {
                    $template_by_id = $this->wpdb->get_row( "SELECT * FROM $table WHERE id = $id");
                    if($template_by_id){
                        $template_result = $template_by_id;
                    }
                    $flag = true;
                }
            }
        }else{
            if($template_result){
                $flag = true;
            }
        }

        return array(
            'active' => $flag,
            'id' => $id,
            'template' => $template_result
        );
    }

    public function get_list_template_by_language($table,$language)
    {
        $templates= $this->wpdb->get_results( "SELECT * FROM $table WHERE (language = '".$language."') ORDER BY ID DESC");
        return $templates;
    }
    
    public function check_have_template_active($templates)
    {
        $flag = false;
        foreach($templates as $key=>$template){
            if($template->active==1){
                $flag = $template;
                break;
            }
        }
        return $flag;
    }

    public function get_all_templates($select="")
    {
        $results = $this->wpdb->get_results($select);
        return $results;
    }

    public function get_template($select="")
    {
        $result = $this->wpdb->get_row($select);
        return $result;
    }

    public function get_template_tile_active($templates)
    {
        $template = $this->check_have_template_active($templates);
        if($template){
            return $template->title;
        }
        return false;
    }

    public function get_file_template( $file_name, $args = array())
    {
        $output = false;
        $path   = MST_CPLFVC_DIR.'/includes/views/'.$file_name.'.php';
        if(file_exists($path)){
            extract($args);
            ob_start();
            require $path;
            $output = ob_get_clean();
        }
        echo $output;
    }

    public function save_template($table,$arg = array())
    {
        return $this->wpdb->insert(
            $table,
            $arg
        );
    }

    public function update_template($table,$argUpdate = array(), $argWhere = array())
    {
        return $this->wpdb->update(
            $table,
            $argUpdate,
            $argWhere
        );
    }

    public function delete_template($table,$argWhere = array())
    {
        return $this->wpdb->delete(
            $table,
            $argWhere
        );
    }

    // GET INFO TEMPLATE SELECTED
    public function is_search_product_page() {
        $check = false;
        if( ( is_search() || is_shop() ) && isset($_GET['post_type']) && 'product' === $_GET['post_type']  ) {
            $check = true;
        }
        return $check;
    }
    public function get_template_search_product($type = 'search') {
        $template   = false;
        $table          = $this->get_table_by_type_template($type);
        $has_template   = $this->get_template_active_by_language($table,$type);
        if($has_template && $has_template["active"]){
            $template = $has_template;
        }
        return $template;
    }
    public function get_template_by_archive()
    {
        $archive    = array('shop','category','tags','brand','attribute');
        $language   = $this->current_language();
        $template   = false;
        foreach($archive as $key => $type){
            if( $this->is_product_layout($type) ){
                $term_id    = $this->get_term_id();
                $table      = $this->get_table_by_type_template($type);
                $has_template = $this->get_template_active_by_language($table,$type,$term_id);
                if($has_template && $has_template["active"]){
                    $template = $has_template;
                }
                break;
            }
        }
        return $template;
    }

    public function get_template_by_product($template_product)
    {
        $table = $this->get_table_name('mst_cplfvc_product_single');
        $has_template = $this->get_template_active_by_language($table,'single',$template_product);
        $template   = false;
        if($has_template && $has_template["active"]){
            $template = $has_template;
        }
        return $template;
    }
    // ELEMENTS TEMPLATE
    public function get_elements()
    {
        $elements = array(
            'shop'  => array(
                    'icon'   => 'icon-mst_cplfvc-product-shop',
                    'elements'  => array(
                            array(
                                'name'          => esc_html__("Categories",MST_CPLFVC),
                                'shortcode'     => 'mst_cplfvc_list_categories',
                            ),
                            array(
                                'name'          => esc_html__("Products",MST_CPLFVC),
                                'shortcode'     => 'mst_cplfvc_list_product',
                            )
                    )
            ),
            'category'      => array(
                'icon'      => 'icon-mst_cplfvc-product-category',
                'elements'  => array(
                    array(
                        'name'          => esc_html__("Product category name",MST_CPLFVC),
                        'shortcode'     => 'mst_cplfvc_product_name_category',
                    ),
                    array(
                        'name'          => esc_html__("Product category description",MST_CPLFVC),
                        'shortcode'     => 'mst_cplfvc_product_description_category',
                    ),
                    array(
                        'name'          => esc_html__("Products by Category",MST_CPLFVC),
                        'shortcode'     => 'mst_cplfvc_product_category',
                    ),
                    array(
                        'name'          => esc_html__("Products by Category with filter",MST_CPLFVC),
                        'shortcode'     => 'mst_cplfvc_product_category_filter',
                    )
                )
            ),
            'tags'          => array(
                'icon'      => 'icon-mst_cplfvc-product-tag',
                'elements'  => array(
                    array(
                        'name'          => esc_html__("Product tag name",MST_CPLFVC),
                        'shortcode'     => 'mst_cplfvc_product_name_tag',
                    ),
                    array(
                        'name'          => esc_html__("Product tag description",MST_CPLFVC),
                        'shortcode'     => 'mst_cplfvc_product_description_tag',
                    ),
                    array(
                        'name'          => esc_html__("Products by Tag",MST_CPLFVC),
                        'shortcode'     => 'mst_cplfvc_product_tags',
                    )
                )
            ),
            'brand'          => array(
                'icon'      => 'icon-mst_cplfvc-product-brand',
                'elements'  => array(
                    array(
                        'name'          => esc_html__("Product brand name",MST_CPLFVC),
                        'shortcode'     => 'mst_cplfvc_product_name_brand',
                    ),
                    array(
                        'name'          => esc_html__("Product brand description",MST_CPLFVC),
                        'shortcode'     => 'mst_cplfvc_product_description_brand',
                    ),
                    array(
                        'name'          => esc_html__("Products by Brand",MST_CPLFVC),
                        'shortcode'     => 'mst_cplfvc_product_brand',
                    )
                )
            ),
            'attribute'          => array(
                'icon'      => 'icon-mst_cplfvc-product-attribute',
                'elements'  => array(
                    array(
                        'name'          => esc_html__("Product attribute name",MST_CPLFVC),
                        'shortcode'     => 'mst_cplfvc_product_name_attribute',
                    ),
                    array(
                        'name'          => esc_html__("Product attribute description",MST_CPLFVC),
                        'shortcode'     => 'mst_cplfvc_product_description_attribute',
                    ),
                    array(
                        'name'          => esc_html__("Products by Attribute",MST_CPLFVC),
                        'shortcode'     => 'mst_cplfvc_product_attribute',
                    )
                )
            ),
            'search'  => array(
                'icon'   => 'icon-mst_cplfvc-product-search',
                'elements'  => array(
                        array(
                            'name'          => esc_html__("Products List",MST_CPLFVC),
                            'shortcode'     => 'mst_cplfvc_search_product',
                        )
                )
            ),
            'product'       => array(
                'icon'      => 'icon-mst_cplfvc-product-single',
                'elements'  => array(
                    array(
                        'name'          => esc_html__("Images",MST_CPLFVC),
                        'shortcode'     => 'mst_cplfvc_product_images',
                    ),
                    array(
                        'name'          => esc_html__("Title",MST_CPLFVC),
                        'shortcode'     => 'mst_cplfvc_product_title',
                    ),
                    array(
                        'name'          => esc_html__("Rating",MST_CPLFVC),
                        'shortcode'     => 'mst_cplfvc_product_rating',
                    ),
                    array(
                        'name'          => esc_html__("Price",MST_CPLFVC),
                        'shortcode'     => 'mst_cplfvc_product_price',
                    ),
                    array(
                        'name'          => esc_html__("Share",MST_CPLFVC),
                        'shortcode'     => 'mst_cplfvc_product_share',
                    ),
                    array(
                        'name'          => esc_html__("Excerpt",MST_CPLFVC),
                        'shortcode'     => 'mst_cplfvc_product_excert',
                    ),
                    array(
                        'name'          => esc_html__("Add To Cart",MST_CPLFVC),
                        'shortcode'     => 'mst_cplfvc_product_add_to_cart',
                    ),
                    array(
                        'name'          => esc_html__("Meta",MST_CPLFVC),
                        'shortcode'     => 'mst_cplfvc_product_cat_product_single',
                    ),
                    array(
                        'name'          => esc_html__("Description",MST_CPLFVC),
                        'shortcode'     => 'mst_cplfvc_product_description',
                    ),
                    array(
                        'name'          => esc_html__("Reviews",MST_CPLFVC),
                        'shortcode'     => 'mst_cplfvc_product_review',
                    ),
                    array(
                        'name'          => esc_html__("Additional Information",MST_CPLFVC),
                        'shortcode'     => 'mst_cplfvc_product_additional_information',
                    ),
                    array(
                        'name'          => esc_html__("Data Tab",MST_CPLFVC),
                        'shortcode'     => 'mst_cplfvc_product_show_tab',
                    ),
                    array(
                        'name'          => esc_html__("Product Related",MST_CPLFVC),
                        'shortcode'     => 'mst_cplfvc_product_relate',
                    ),
                    array(
                        'name'          => esc_html__("Product Upsell",MST_CPLFVC),
                        'shortcode'     => 'mst_cplfvc_product_upsell',
                    )
                )
            )
        );
        return $elements;
    }

    public function show_elements($type = array())
    {
        if(isset($type['elements']) && !empty($type['elements']))
        {
            foreach( $type['elements'] as $key => $element ){
                ?>
                <div class="vc_el-container">
                    <a id="<?php echo esc_attr($element['shortcode']); ?>" data-tag="<?php echo esc_attr($element['shortcode']); ?>" class="dropable_el vc_shortcode-link" href="#" data-vc-clickable="">
                    <i class="vc_general vc_element-icon <?php echo esc_attr($type['icon']); ?>"></i> 
                    <span data-vc-shortcode-name=""><?php echo esc_html($element['name']); ?></span></a>
                </div>
                <?php
            }
        }
    }

    // GET Archive Info
    public function get_attr_archive_info($type)
    {
        $data = array();
        $txt_depend_template = '';
        $args_query = array('page' => 'mst_cplfvc-active-templates' );
        switch ($type) {
            case 'category':
                $args_query['type']     = $type;
                $desc                   = esc_html__('Template for product category page.',MST_CPLFVC);
                $txt_all                = esc_html__('Product category templates',MST_CPLFVC);
                break;
            case 'tags':
                $args_query['type']     = $type;
                $desc                   = esc_html__('Template for product tag page.',MST_CPLFVC);
                $txt_all                = esc_html__('Product tag  templates',MST_CPLFVC);
                break;
            case 'brand':
                $args_query['type'] = $type;
                $desc                   = esc_html__('Template for product brand page.',MST_CPLFVC);
                $txt_all                = esc_html__('Product brand templates',MST_CPLFVC);
                break;
            case 'attribute':
                $args_query['type']     = $type;
                $desc                   = esc_html__('Template for product attribute page.',MST_CPLFVC);
                $txt_all                = esc_html__('Product attribute templates',MST_CPLFVC);
                $txt_depend_template    = esc_html__('Template by product attribute',MST_CPLFVC);
                break;
            default: // product detail
                $args_query['type']     = 'single';
                $desc                   = esc_html__('Template for product page.',MST_CPLFVC);
                $txt_all                = esc_html__('Product Templates',MST_CPLFVC);
                $txt_depend_template    = esc_html__('Template by product category',MST_CPLFVC);
                break;
        }
        $data['desc']                   = $desc;
        $data['desc_url']               = add_query_arg($args_query , esc_url(admin_url('admin.php')) );
        $data['txt_all']                = $txt_all;
        $data['txt_depend_template']    = $txt_depend_template;
        return $data;
    }

    public function get_class_extra()
    {
        switch ( $this->currentTheme() )
        {
            case 'thegem':
                $class_extra = 'single-product-content row';
                break;
            case 'dt-the7':
                $class_extra = 'mstcplfwpb-dt-the7-theme';
                break;
            case 'total':
                $class_extra = 'mstcplfwpb-total-theme';
                break;
            case 'porto':
                $class_extra = 'product-summary-wrap';
                break;
            case 'shopkeeper':
                $class_extra = 'product_layout_classic default-layout';
                break;
            default:
                $class_extra = '';
                break;
        }
        return $class_extra;
    }
}