<?php
namespace mysterious\productlayout\classes;

class plugin
{
    public static function create_table($table,$charset_collate)
    {   
        $sql = 'CREATE TABLE '.$table.' (
                      `id` int(11) NOT NULL AUTO_INCREMENT,
                      `title` varchar(255) NOT NULL,
                      `images` TEXT NULL,
                      `content` TEXT NULL,
                      `language` varchar(255) NOT NULL default "",
                      `active` int(11) NOT NULL default 0,
                      UNIQUE KEY id (id)
                      ) '.$charset_collate.';';
        require_once ABSPATH.'wp-admin/includes/upgrade.php';
        dbDelta($sql);
    }
    
    public static function check_templates($table)
    {
        global $wpdb;
        $check = $wpdb->get_results( "SELECT * FROM $table");
        if($check){
            return true;
        }
        return false;
    }
    
    public static function add_row_table_template($table,$title,$content,$active)
    {
        global $wpdb;
        $wpdb->insert( $table, array( 'title' => $title,'images' => '','content' => $content,'language' => '','active' => $active), array( '%s', '%s','%s','%s','%d') );
    }
    
    public static function load_table_template($folder_name,$table)
    {
        $dir = MST_CPLFVC_DIR. '/customize-core/'.$folder_name.'/';
        $ts = scandir($dir); 
        foreach ($ts as $k => $v) {
            if (in_array($v, array('.', '..', '.DS_Store'))) {
                unset($ts[$k]);
            }
            if(is_file($dir.$v)){
                unset($ts[$k]);
            }
        }
        $flag_template = self::check_templates($table);
        foreach ($ts as $k => $v) {
            $t_file =$dir.$v . '/index.php';
            if (!is_file($t_file)) {
                continue;
            }
            $data_file = require $t_file;
            if(!$flag_template){
                self::add_row_table_template($table,$data_file['title'],$data_file['data'],0);
            }
        }
    }
    public static function activate()
    {
        global $wpdb;
        $array_tables = array(
            'product-single'    => 'mst_cplfvc_product_single',
            'product-tag'       => 'mst_cplfvc_product_tags',
            'product-category'  => 'mst_cplfvc_product_category',
            'product-shop'      => 'mst_cplfvc_product_shop',
            'product-brand'     => 'mst_cplfvc_product_brand',
            'product-attribute' => 'mst_cplfvc_product_attribute',
            'product-search'    => 'mst_cplfvc_product_search',
            'archive-loop'      => 'mst_cplfvc_product_loop',
        );
        foreach($array_tables as $folder_name => $name){
            $table = $wpdb->prefix.$name;
            self::addTableTemplates($table,$folder_name);
        }
    }

    // UPDATE 08/03/2021
    public static function checkDataType($table, $column)
    {
        global $wpdb;
        $datatype   = $wpdb->get_row("SELECT DATA_TYPE FROM INFORMATION_SCHEMA.COLUMNS WHERE table_name = '$table' AND COLUMN_NAME = '$column' ");
        $type       = isset($datatype->DATA_TYPE) ? $datatype->DATA_TYPE : false;
        if($type==='varchar'){
            $wpdb->query("ALTER TABLE $table MODIFY $column TEXT NULL");
        }
    }
    public static function addOrUpdateColumns($table)
    {
        global $wpdb;
        $row_table = $wpdb->get_col( "DESC " . $table, 0 );
        if(!in_array('language', $row_table)){
            $wpdb->query("ALTER TABLE $table ADD COLUMN `language` varchar(255) NOT NULL default '' AFTER `content`");
        }
        self::checkDataType($table,'images');
    }
    public static function addTableTemplates($table,$folder_name)
    {
        global $wpdb;
        $charset_collate = $wpdb->get_charset_collate();
        if ($wpdb->get_var("show tables like '$table'") != $table){
            self::create_table($table,$charset_collate);     
        }else{
            self::addOrUpdateColumns($table);
        }
        
        if($folder_name != 'product-search') {
            self::load_table_template($folder_name,$table);
        }
        
    }
}
