<?php
namespace mysterious\productlayout\controllers;
use function mysterious\productlayout\productLayoutWPB;
class hooks
{
    private static $_instance = null;

    public function __construct()
    {
        add_action( 'wc_product_layout_share', array( $this, 'wc_product_layout_share'), 10, 1 );
        add_action( 'product_layout_wpb_before_main_content', array( $this, 'product_layout_wpb_before_main_content'), 10, 1 );
        add_action( 'product_layout_wpb_after_main_content', array( $this, 'product_layout_wpb_after_main_content'), 10, 1 );
        add_action( 'product_layout_wpb_before_content', array( $this, 'product_layout_wpb_before_content'), 10, 1 );
        add_action( 'product_layout_wpb_after_content', array( $this, 'product_layout_wpb_after_content'), 10, 1 );
        add_action( 'product_page_wpb_show_content', array( $this, 'product_page_wpb_show_content'), 10, 1 );
    }
    public static function instance()
    {
        if (is_null(self::$_instance)) {
            self::$_instance = new self();
        }
        return self::$_instance;
    }
    
    public function wc_product_layout_share($postID)
    {
        $permalink  = get_the_permalink($postID);
		$title      = get_the_title($postID);
        $image      = wp_get_attachment_url( get_post_meta( $postID, '_thumbnail_id', true ) );
		?>
		<a href="//twitter.com/intent/tweet?text=<?php echo urlencode( $title ); ?>&amp;url=<?php echo esc_url( $permalink ); ?>" class="mstcplfwpb-icon-button twitter" title="<?php esc_attr_e( 'Twitter', 'customize-product-layout-builder-for-visual-composer' ); ?>" target="_blank"><i class="fab fa-twitter icon-twitter"></i><span></span></a>
        <a href="//facebook.com/sharer/sharer.php?u=<?php echo esc_url( $permalink ); ?>" title="<?php esc_attr_e( 'Facebook', 'customize-product-layout-builder-for-visual-composer' ); ?>" class="mstcplfwpb-icon-button facebook" target="_blank"><i class="fab fa-facebook-f icon-facebook" aria-hidden="true"></i><span></span></a>
		<a href="//plus.google.com/share?url=<?php echo esc_url( $permalink ); ?>" class="mstcplfwpb-icon-button google-plus" title="<?php esc_attr_e( 'Google +', 'customize-product-layout-builder-for-visual-composer' ); ?>" target="_blank"><i class="fab fa-google-plus-g icon-google-plus"></i><span></span></a>
		<a href="//linkedin.com/shareArticle?mini=true&amp;url=<?php echo esc_url( $permalink ); ?>&amp;title=<?php echo urlencode( $title ); ?>" class="mstcplfwpb-icon-button linkedin" target="_blank" title="<?php esc_attr_e( 'LinkedIn', 'customize-product-layout-builder-for-visual-composer' ); ?>"><i class="fab fa-linkedin-in icon-linkedin"></i><span></span></a>
		<a href="//pinterest.com/pin/create/button/?url=<?php echo esc_url( $permalink ); ?>&amp;media=<?php echo esc_url( $image ); ?>" title="<?php esc_attr_e( 'Pinterest', 'customize-product-layout-builder-for-visual-composer' ); ?>" class="mstcplfwpb-icon-button pinterest" target="_blank"><i class="fab fa-pinterest-p icon-pinterest"></i><span></span></a>
        <a href="mailto:?subject=<?php echo urlencode( $title ); ?>&amp;body=<?php echo esc_url( $permalink ); ?>" title="<?php esc_attr_e( 'Mail', 'customize-product-layout-builder-for-visual-composer' ); ?>" class="mstcplfwpb-icon-button envelope" target="_blank"><i class="fas fa-envelope-square icon-envelope"></i><span></span></a>
        <?php
    }

    public function product_layout_wpb_before_main_content($is_theme)
    {    
        switch ($is_theme)
        {
            case 'amely':
                echo '<div class="container"><div class="inner-page-wrap"><div id="main" class="site-content">';
                break;
            case 'ekko':
                echo '<section class="product-archie-product-wrapper">'; 
                break;
            case 'woodmart':
                if(!get_option( 'wc_settings_tab_product_tag_hide_sidebar') || get_option( 'wc_settings_tab_product_tag_hide_sidebar')==="no"){
                    do_action( 'woocommerce_sidebar' );
                }
                break;
            case 'flatsome':
                ?>
                <div class="row category-page-row">
                <div class="col large-3 hide-for-medium <?php flatsome_sidebar_classes(); ?>">
                    <?php flatsome_sticky_column_open( 'category_sticky_sidebar' ); ?>
                    <div id="shop-sidebar" class="sidebar-inner col-inner">
                        <?php
                            if(is_active_sidebar('shop-sidebar')){
                                dynamic_sidebar('shop-sidebar');
                            }
                        ?>
                        </div>
                    <?php flatsome_sticky_column_close( 'category_sticky_sidebar' ); ?>
                </div>
	            <div class="col large-9">
                <?php
                break;
            case 'total':
                echo '<div id="content-wrap" class="container wpex-clr">';
	            wpex_hook_primary_before();
			    echo '<div id="primary" class="content-area wpex-clr">';
				wpex_hook_content_before();
				echo '<div id="content" class="site-content wpex-clr">';
				wpex_hook_content_top();
				echo '<article class="entry-content entry wpex-clr">';
                break;
            case 'shopkeeper':
                $shop_sidebar_class = '';
                echo '<div id="primary" class="content-area shop-page '.esc_attr($shop_sidebar_class).'">';
	            echo '<div class="row">';
		        echo '<div class="large-12 columns">';
			    echo '<div class="before_main_content">';
                break;
            default:
                break;
        }
        do_action( 'woocommerce_before_main_content' );
    }

    public function product_layout_wpb_after_main_content($is_theme)
    {
        switch ($is_theme)
        {
            case 'amely':
                echo '</div></div></div>';
                do_action( 'woocommerce_after_main_content' );
                do_action( 'woocommerce_sidebar' );
                break;
            case 'ekko':
                echo '</section>'; 
                break;
            case 'woodmart':
                do_action( 'woocommerce_after_main_content' );
                break;
            case 'flatsome':
                do_action( 'flatsome_products_after' );	 
		        do_action( 'woocommerce_after_main_content' );
                echo '</div></div>';
                break;
            case 'total':
                do_action( 'woocommerce_after_main_content' );
				echo '</article>';
				wpex_hook_content_bottom();
				echo '</div>';
                wpex_hook_content_after();
                echo '</div>';
                wpex_hook_primary_after();
                echo '</div>';
                break;
            case 'shopkeeper':
                do_action('woocommerce_after_main_content');
                echo '</div></div></div></div></div></div>';
                break;
            case 'mato':
                do_action('woocommerce_after_main_content');
                break;
            default:
                do_action( 'woocommerce_after_main_content' );
                do_action( 'woocommerce_sidebar' );
                break;
        }
    }

    public function product_layout_wpb_before_content($is_theme)
    {
        switch ($is_theme)
        {
            case 'porto':
                echo '<div class="archive-products">';
                break;
            case 'ekko':
                    echo '<style>nav.woocommerce-breadcrumb {display: none;}</style>';
                    echo '<div class="container"><div class="col-xs-12 col-sm-12 col-md-12 col-lg-12 woo-3-columns">'; 
                break;
            case 'mato':
                if(is_active_sidebar('shop_sidebar'))
                {
                    global $woocommerce_loop;
                    $woocommerce_loop["columns"] = 3;
                    echo '<div class="row">';
                    echo '<div class="col-12 col-md-8">';
                }
                break;
            case 'woodmart':
                do_action( 'woodmart_before_shop_page' ); 
                do_action( 'woodmart_shop_filters_area' );
                echo '<div class="woodmart-active-filters">';
                do_action( 'woodmart_before_active_filters_widgets' );
                the_widget( 'WC_Widget_Layered_Nav_Filters', array(
                    'title' => ''
                ), array() );
                do_action( 'woodmart_after_active_filters_widgets' );
                echo '</div>';
                echo '<div class="woodmart-shop-loader"></div>';
                break;
            case 'total':
                echo '<style>nav.woocommerce-breadcrumb {display: none;}article.entry-content.entry.wpex-clr .content-area{width:100%;}</style>';
                break;
            case 'shopkeeper':
                $shop_content_class = 'large-12 columns';
                $parent_id      = get_queried_object_id();
                $categories     = get_terms( 'product_cat', array( 'hide_empty' => \Shopkeeper_Opt::getOption( 'hide_empty_categories', false ), 'parent' => $parent_id ) );
                $display_mode 	= woocommerce_get_loop_display_mode();
                echo '</div>';
                echo '<div id="content" class="site-content" role="main">';
                echo '<div class="row">';
                echo '<div class="'.esc_attr( $shop_content_class ).'">';
                echo '<div class="large-12 mobile-columns-'.\Shopkeeper_Opt::getOption( 'mobile_columns', 2 ).'">';
                break;
            default:
                break;
        }
        
    }

    public function product_layout_wpb_after_content($is_theme)
    {
        switch ($is_theme)
        {
            case 'ekko':
                echo '</div></div>'; 
            break;
            case 'mato':
                if(is_active_sidebar('shop_sidebar'))
                {
                    echo '</div>';
                        echo '<div class="site-sidebar col-12 col-md-4">';
                            echo '<div class="wrap">';
                            dynamic_sidebar('shop_sidebar');
                            echo '</div>';
                        echo '</div>';
                    echo '</div>';
                }
                break;
            case 'porto':
                echo '</div>';
                break;
            case 'shopkeeper':
                echo '</div>';
                break;
            default:
                break;
        }
    }

    public function product_page_wpb_show_content($result)
    {
        $is_theme_active = productLayoutWPB()->currentTheme();
        switch ($is_theme_active)
        {
            case 'shopkeeper':
                echo '<div class="large-12 xlarge-10 xxlarge-9 large-centered columns"><div class="product_content_wrapper">';
                break;
            default:
                break;
        }
        $content 		= isset($result["template"]->content) ? $result["template"]->content : "";
		$template_id    = isset($result["template"]->id) ? intval($result["template"]->id) : 0;
		productLayoutWPB()->show_template_content($template_id,$content);
        switch ($is_theme_active)
        {
            case 'shopkeeper':
                echo '</div></div>';
                break;
            default:
                break;
        }
    }
}