<?php
namespace mysterious\productlayout\controllers;
use mysterious\productlayout\classes\vcmap;
use mysterious\productlayout\classes\shortcodes;
use function mysterious\productlayout\productLayoutWPB;
class init
{
    private static $_instance = null;
    public $post_type = false;
    public function __construct()
    {
        $this->post_type = productLayoutWPB()->get_post_type();
        add_action('init', array($this, 'check_plugin'));
        if( productLayoutWPB()->is_check_require() )
        {
            add_action('admin_menu', array($this, 'admin_menu_settings'));
            add_action('admin_enqueue_scripts', array($this, 'admin_enqueue_scripts'));
            add_action('wp_enqueue_scripts', array($this, 'wp_enqueue_scripts'));
            $this->load_dependencies();
        }

        
    }
    public static function instance()
    {
        if (is_null(self::$_instance)) {
            self::$_instance = new self();
        }
        return self::$_instance;
    }
    
    public function check_plugin()
    {
        if(!defined('WOOCOMMERCE_VERSION')){
            add_action('admin_notices',array($this,'woocommerce_require'));
            return;
        }
        if (!defined('WPB_VC_VERSION')) {
            add_action('admin_notices', array($this, 'wpbakery_page_builder_require'));
            return;
        }
        productLayoutWPB()->register_post_type();
        vcmap::instance();
        shortcodes::instance();
    }
    public function woocommerce_require()
    {
        $plugin = get_plugin_data(MST_CPLFVC_FILE);
		echo '<div class="error">
                <p><strong>'.esc_html($plugin['Name']).'</strong> requires <strong><a href="https://wordpress.org/plugins/woocommerce/" target="_blank">WooCommerce</a></strong> plugin to be installed and activated on your site.</p>
			  </div>';
    }
    public function wpbakery_page_builder_require()
    {
        $plugin = get_plugin_data(MST_CPLFVC_FILE);
        echo '<div class="error">
                <p><strong>'.esc_html($plugin['Name']).'</strong> requires <strong><a href="https://codecanyon.net/item/visual-composer-page-builder-for-wordpress/242431" target="_blank">WPbakery page builder</a></strong> plugin to be installed and activated on your site.</p>
			  </div>';
    }

    public function admin_menu_settings()
    {
        add_submenu_page( 
            'woocommerce',
            esc_html__( 'Product Layout',MST_CPLFVC),
            esc_html__( 'Product Layout',MST_CPLFVC),
            'manage_woocommerce',
            'mst_cplfvc-active-templates',
            array($this, 'callback_templates')
        );

    }

    public function callback_templates()
    {
        $type           = isset($_GET["type"]) ? sanitize_text_field($_GET["type"]) : "" ;
        $table          = productLayoutWPB()->get_table_by_type_template($type);
        $template_image = MST_CPLFVC_URL.'assets/images/template.png';
        $language       = productLayoutWPB()->current_language();
        $templates      = productLayoutWPB()->get_list_template_by_language($table,$language);
        $addnew         = !empty($type) ? add_query_arg( array('post_type' => $this->post_type,'type' => $type), esc_url(admin_url('post-new.php')) ) : add_query_arg( array('post_type' => $this->post_type), esc_url(admin_url('post-new.php')) );
        $title_active   = productLayoutWPB()->get_template_tile_active($templates);
        require_once MST_CPLFVC_INC.'/views/templates.php';
    }
    
    public function load_dependencies()
    {
        hooks::instance();
        backend::instance();
        route::instance();
        ajax::instance();
        fields::instance();
    }
    public function is_page_templates()
    {
        global $pagenow;
        if( $pagenow=='admin.php' && isset($_GET['page']) && $_GET['page'] === 'mst_cplfvc-active-templates' ){
            return true;
        }
        return false;
    }
	public function is_page_post()
    {
        global $pagenow;
        if( $pagenow=='post.php'  || $pagenow=='post-new.php'){
            return true;
        }
        return false;
    }
    public function admin_enqueue_scripts()
    {
        $data_localize_script = productLayoutWPB()->get_localize_script();
        wp_enqueue_style('mstcplfwpb-admin',MST_CPLFVC_URL.'assets/css/admin.css', array(), MST_CPLFVC_VERSION);
        wp_register_style('mstcplfwpb-tabs', MST_CPLFVC_URL . 'assets/css/tabs.css', array(), MST_CPLFVC_VERSION);
        wp_register_script('mstcplfwpb-tabs', MST_CPLFVC_URL . 'assets/js/tabs.js', array('jquery'), MST_CPLFVC_VERSION);
        if($this->is_page_templates())
        {
            wp_enqueue_style('mstcplfwpb-templates', MST_CPLFVC_URL.'assets/css/templates.css', array(), MST_CPLFVC_VERSION);
            wp_register_script('mstcplfwpb-templates', MST_CPLFVC_URL.'assets/js/template.js', array('jquery'), MST_CPLFVC_VERSION);
            wp_enqueue_script('mstcplfwpb-templates');
            wp_localize_script(
                'mstcplfwpb-templates',
                'mst_product_layout_data',
                $data_localize_script
            );
        }
		if( $this->is_page_post() ){
            wp_enqueue_script('mstcplfwpb-tabs');
            wp_enqueue_media();
        }
 
    }
    public function wp_enqueue_scripts()
    {
        wp_enqueue_style('mstcplfwpb-frontend',MST_CPLFVC_URL.'assets/css/frontend.css', array(), MST_CPLFVC_VERSION);
		wp_enqueue_style('mstcplfwpb-frontend-font',productLayoutWPB()->get_awesome(), array(), MST_CPLFVC_VERSION);
    }

    
}