<?php
namespace mysterious\productlayout\controllers;
use function mysterious\productlayout\productLayoutWPB;
class route
{
    private static $_instance = null;

    public function __construct()
    {
        add_action( 'template_redirect',array($this,'callback_redirect_template'), 9999);
        add_filter(	'wc_get_template_part', array($this,'callback_template_product_detail'),50,3);
        add_filter( 'woocommerce_redirect_single_search_result', '__return_false' );
    }
    public static function instance()
    {
        if (is_null(self::$_instance)) {
            self::$_instance = new self();
        }
        return self::$_instance;
    }
    
    public function callback_redirect_template()
    {
        if(defined('WOOCOMMERCE_VERSION')){
            $is_check = false;
            if( productLayoutWPB()->is_search_product_page()  ) {
                $has_template   = productLayoutWPB()->get_template_search_product();
                if($has_template && $has_template["active"]){
                    $is_check = true;
                }
                
            } else {
                if( productLayoutWPB()->get_template_by_archive() ){
                    $is_check = true;
                }
            }
            
            if( $is_check ) {
                add_filter( 'template_include',  array($this,'template_include'), 9999);
            }
        }
    }

    public function template_include($template)
    {
        $template_redirect = MST_CPLFVC_INC.'/views/archive-product.php';
        if (file_exists($template_redirect)) {
            return $template_redirect;
        }
        return $template;
    }

    public function get_template_id_by_product()
    {
        global $post;
      	$template_id='';
		if(empty($post)) return;
		if(defined('WOOCOMMERCE_VERSION')){
            $terms = wp_get_post_terms($post->ID, 'product_cat');
            $language = productLayoutWPB()->current_language();
            if(!empty($language)){
                $name_meta_single = 'mst_pclfvc_product_single_'.$language;
                $name_term_cat_by_single = 'mst_pclfvc_product_cat_single_'.$language;
            }else{
                $name_meta_single = 'mst_pclfvc_product_single';
                $name_term_cat_by_single = 'mst_pclfvc_product_cat_single';
            }
            if(get_post_meta($post->ID,$name_meta_single,true)){
                $template_id = get_post_meta($post->ID,$name_meta_single,true);
            }else{
                foreach ($terms as $term){
                    $template_product_cat = get_term_meta( $term->term_id, $name_term_cat_by_single, true );
                    if( $template_product_cat ){
                        $template_id = $template_product_cat;
                        break;
                    }
                }
            }
        }	
		return $template_id;
    }
    public function callback_template_product_detail($template, $slug, $name)
    {
        if( $slug === 'content' && $name ==='single-product' ){
            global $template_selected;
            $template_product = $this->get_template_id_by_product();
            if( productLayoutWPB()->get_template_by_product($template_product) ){
                $template_selected = $template_product;
                $template_redirect = MST_CPLFVC_INC.'/views/content-single-product.php';
                if (file_exists($template_redirect)) {
                    $template = $template_redirect;
                }
            }
        } 
        return $template;
    }
}